<?php

/*
  Plugin Name: Fiddlemail
  Description: Identify and block disposable fake email addresses to prevent junk users and comments.
  Version: 1.1.0
  Author: fiddlemail.com
  Author URI: https://fiddlemail.com
  Text Domain: fiddlemail
  License: GPLv2
 */

/*
  Copyright (C) 2018 fiddlemail.com

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

defined('ABSPATH') or die('No script kiddies please!');

define('FM_INC_PATH', dirname(__FILE__) . '/includes');
include_once FM_INC_PATH . '/Fiddlemail.inc.php';
include_once FM_INC_PATH . '/FiddlemailInstall.inc.php';

//load_plugin_textdomain('fiddlemail', false, basename(dirname(__FILE__)) . '/languages');

register_activation_hook(__FILE__, array('FiddlemailInstall', 'onPluginActivate'));
register_deactivation_hook(__FILE__, array('FiddlemailInstall', 'onPluginDeactivate'));

if(is_admin()) {
	add_action('admin_menu', array('Fiddlemail', 'onAdminMenu'));
	add_action('admin_notices', array('Fiddlemail', 'onAdminNotices'));
}

// Hooks, Funktionen
$filter_on = get_option('fm_filter');
$comment_handling = get_option('fm_comment_handling');
if($filter_on == FIDDLEMAIL_FILTER_MAIL) {
	add_action('pre_comment_on_post', array('Fiddlemail', 'setCommentContext'));
	if($comment_handling == FIDDLEMAIL_COMMENT_SPAM) {
		add_filter('preprocess_comment', array('Fiddlemail', 'checkComment'), 5, 1);
		add_filter('pre_comment_approved', array('Fiddlemail', 'handleComment'), 99, 2);
	}
    
	add_filter('is_email', array('Fiddlemail', 'checkEmail'), 20);
	add_filter('registration_errors', array('Fiddlemail', 'addErrorString'));
	add_filter('user_profile_update_errors', array('Fiddlemail', 'addErrorString'));
	add_filter('login_errors', array('Fiddlemail', 'addErrorString'));
} elseif($filter_on == FIDDLEMAIL_FILTER_COMMENTS) {
    add_filter('preprocess_comment', array('Fiddlemail', 'checkComment'));
	add_filter('pre_comment_approved', array('Fiddlemail', 'handleComment'), 99, 2);
} elseif ($filter_on == FIDDLEMAIL_FILTER_REGISTRATION) {
    add_filter('registration_errors', array('Fiddlemail', 'checkRegistration'), 10, 3);
}

add_filter('plugin_action_links', array('FiddlemailInstall', 'showSettingsLink'), 10, 2);
add_action('plugins_loaded', array('FiddlemailInstall', 'onDatabaseCheck'));
